18791: allow single-host-single-hostname to manage LE certs
[arvados.git] / tools / salt-install / provision.sh
1 #!/bin/bash
2
3 # Copyright (C) The Arvados Authors. All rights reserved.
4 #
5 # SPDX-License-Identifier: CC-BY-SA-3.0
6
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
10 #
11 # vagrant up
12
13 set -o pipefail
14
15 # capture the directory that the script is running from
16 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
17
18 usage() {
19   echo >&2
20   echo >&2 "Usage: ${0} [-h] [-h]"
21   echo >&2
22   echo >&2 "${0} options:"
23   echo >&2 "  -d, --debug                                 Run salt installation in debug mode"
24   echo >&2 "  -c <local.params>, --config <local.params>  Path to the local.params config file"
25   echo >&2 "  -t, --test                                  Test installation running a CWL workflow"
26   echo >&2 "  -r, --roles                                 List of Arvados roles to apply to the host, comma separated"
27   echo >&2 "                                              Possible values are:"
28   echo >&2 "                                                api"
29   echo >&2 "                                                controller"
30   echo >&2 "                                                dispatcher"
31   echo >&2 "                                                keepproxy"
32   echo >&2 "                                                keepstore"
33   echo >&2 "                                                keepweb"
34   echo >&2 "                                                shell"
35   echo >&2 "                                                webshell"
36   echo >&2 "                                                websocket"
37   echo >&2 "                                                workbench"
38   echo >&2 "                                                workbench2"
39   echo >&2 "                                              Defaults to applying them all"
40   echo >&2 "  -h, --help                                  Display this help and exit"
41   echo >&2 "  --dump-config <dest_dir>                    Dumps the pillars and states to a directory"
42   echo >&2 "                                              This parameter does not perform any installation at all. It's"
43   echo >&2 "                                              intended to give you a parsed sot of configuration files so"
44   echo >&2 "                                              you can inspect them or use them in you Saltstack infrastructure."
45   echo >&2 "                                              It"
46   echo >&2 "                                                - parses the pillar and states templates,"
47   echo >&2 "                                                - downloads the helper formulas with their desired versions,"
48   echo >&2 "                                                - prepares the 'top.sls' files both for pillars and states"
49   echo >&2 "                                                  for the selected role/s"
50   echo >&2 "                                                - writes the resulting files into <dest_dir>"
51   echo >&2 "  -v, --vagrant                               Run in vagrant and use the /vagrant shared dir"
52   echo >&2 "  --development                               Run in dev mode, using snakeoil certs"
53   echo >&2
54 }
55
56 arguments() {
57   # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
58   if ! which getopt > /dev/null; then
59     echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
60     exit 1
61   fi
62
63   TEMP=$(getopt -o c:dhp:r:tv \
64     --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
65     -n "${0}" -- "${@}")
66
67   if [ ${?} != 0 ];
68     then echo "Please check the parameters you entered and re-run again"
69     exit 1
70   fi
71   # Note the quotes around `$TEMP': they are essential!
72   eval set -- "$TEMP"
73
74   while [ ${#} -ge 1 ]; do
75     case ${1} in
76       -c | --config)
77         CONFIG_FILE=${2}
78         shift 2
79         ;;
80       -d | --debug)
81         LOG_LEVEL="debug"
82         shift
83         set -x
84         ;;
85       --dump-config)
86         if [[ ${2} = /* ]]; then
87           DUMP_SALT_CONFIG_DIR=${2}
88         else
89           DUMP_SALT_CONFIG_DIR=${PWD}/${2}
90         fi
91         ## states
92         S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
93         ## formulas
94         F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
95         ## pillars
96         P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
97         ## tests
98         T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
99         DUMP_CONFIG="yes"
100         shift 2
101         ;;
102       --development)
103         DEV_MODE="yes"
104         shift 1
105         ;;
106       -r | --roles)
107         for i in ${2//,/ }
108           do
109             # Verify the role exists
110             if [[ ! "database,api,controller,keepstore,websocket,keepweb,workbench2,webshell,keepproxy,shell,workbench,dispatcher" == *"$i"* ]]; then
111               echo "The role '${i}' is not a valid role"
112               usage
113               exit 1
114             fi
115             ROLES="${ROLES} ${i}"
116           done
117           shift 2
118         ;;
119       -t | --test)
120         TEST="yes"
121         shift
122         ;;
123       -v | --vagrant)
124         VAGRANT="yes"
125         shift
126         ;;
127       --)
128         shift
129         break
130         ;;
131       *)
132         usage
133         exit 1
134         ;;
135     esac
136   done
137 }
138
139 copy_custom_cert() {
140   cert_dir=${1}
141   cert_name=${2}
142
143   mkdir -p /srv/salt/certs
144
145   if [ -f ${cert_dir}/${cert_name}.crt ]; then
146     cp -v ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
147   else
148     echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
149     exit 1
150   fi
151   if [ -f ${cert_dir}/${cert_name}.key ]; then
152     cp -v ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
153   else
154     echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
155     exit 1
156   fi
157 }
158
159 DEV_MODE="no"
160 CONFIG_FILE="${SCRIPT_DIR}/local.params"
161 CONFIG_DIR="local_config_dir"
162 DUMP_CONFIG="no"
163 LOG_LEVEL="info"
164 CONTROLLER_EXT_SSL_PORT=443
165 TESTS_DIR="tests"
166
167 CLUSTER=""
168 DOMAIN=""
169
170 # Hostnames/IPs used for single-host deploys
171 IP_INT="127.0.1.1"
172
173 # Initial user setup
174 INITIAL_USER=""
175 INITIAL_USER_EMAIL=""
176 INITIAL_USER_PASSWORD=""
177
178 CONTROLLER_EXT_SSL_PORT=8000
179 KEEP_EXT_SSL_PORT=25101
180 # Both for collections and downloads
181 KEEPWEB_EXT_SSL_PORT=9002
182 WEBSHELL_EXT_SSL_PORT=4202
183 WEBSOCKET_EXT_SSL_PORT=8002
184 WORKBENCH1_EXT_SSL_PORT=443
185 WORKBENCH2_EXT_SSL_PORT=3001
186
187 SSL_MODE="self-signed"
188 USE_LETSENCRYPT_ROUTE53="no"
189 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/certs"
190
191 ## These are ARVADOS-related parameters
192 # For a stable release, change RELEASE "production" and VERSION to the
193 # package version (including the iteration, e.g. X.Y.Z-1) of the
194 # release.
195 # The "local.params.example.*" files already set "RELEASE=production"
196 # to deploy  production-ready packages
197 RELEASE="development"
198 VERSION="latest"
199
200 # These are arvados-formula-related parameters
201 # An arvados-formula tag. For a stable release, this should be a
202 # branch name (e.g. X.Y-dev) or tag for the release.
203 # ARVADOS_TAG="2.2.0"
204 # BRANCH="main"
205
206 # Other formula versions we depend on
207 POSTGRES_TAG="v0.43.0"
208 NGINX_TAG="v2.8.0"
209 DOCKER_TAG="v2.0.7"
210 LOCALE_TAG="v0.3.4"
211 LETSENCRYPT_TAG="v2.1.0"
212
213 # Salt's dir
214 DUMP_SALT_CONFIG_DIR=""
215 ## states
216 S_DIR="/srv/salt"
217 ## formulas
218 F_DIR="/srv/formulas"
219 ## pillars
220 P_DIR="/srv/pillars"
221 ## tests
222 T_DIR="/tmp/cluster_tests"
223
224 arguments ${@}
225
226 if [ -s ${CONFIG_FILE} ]; then
227   source ${CONFIG_FILE}
228 else
229   echo >&2 "You don't seem to have a config file with initial values."
230   echo >&2 "Please create a '${CONFIG_FILE}' file as described in"
231   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
232   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
233   exit 1
234 fi
235
236 if [ ! -d ${CONFIG_DIR} ]; then
237   echo >&2 "You don't seem to have a config directory with pillars and states."
238   echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
239   echo >&2 "  * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
240   echo >&2 "  * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
241   exit 1
242 fi
243
244 if grep -q 'fixme_or_this_wont_work' ${CONFIG_FILE} ; then
245   echo >&2 "The config file ${CONFIG_FILE} has some parameters that need to be modified."
246   echo >&2 "Please, fix them and re-run the provision script."
247   exit 1
248 fi
249
250 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
251   echo >&2 "ERROR: <CLUSTER> must be exactly 5 alphanumeric characters long"
252   echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
253   exit 1
254 fi
255
256 # Only used in single_host/single_name deploys
257 if [ ! -z "${HOSTNAME_EXT}" ] ; then
258   # We need to add some extra control vars to manage a single certificate vs. multiple
259   USE_SINGLE_HOSTNAME="yes"
260 else
261   USE_SINGLE_HOSTNAME="no"
262   # We set this variable, anyway, so sed lines do not fail and we don't need to add more
263   # conditionals
264   HOSTNAME_EXT="${CLUSTER}.${DOMAIN}"
265 fi
266
267 if [ "${DUMP_CONFIG}" = "yes" ]; then
268   echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
269 else
270   # Install a few dependency packages
271   # First, let's figure out the OS we're working on
272   OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d=  |cut -f 2 -d \")
273   echo "Detected distro: ${OS_ID}"
274
275   case ${OS_ID} in
276     "centos")
277       echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
278       sed -i 's/SELINUX=enforcing/SELINUX=permissive' /etc/sysconfig/selinux
279       setenforce permissive
280       yum install -y  curl git jq
281       ;;
282     "debian"|"ubuntu")
283       DEBIAN_FRONTEND=noninteractive apt update
284       DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
285       ;;
286   esac
287
288   if which salt-call; then
289     echo "Salt already installed"
290   else
291     curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
292     sh /tmp/bootstrap_salt.sh -XdfP -x python3
293     /bin/systemctl stop salt-minion.service
294     /bin/systemctl disable salt-minion.service
295   fi
296
297   # Set salt to masterless mode
298   cat > /etc/salt/minion << EOFSM
299 failhard: "True"
300
301 file_client: local
302 file_roots:
303   base:
304     - ${S_DIR}
305     - ${F_DIR}/*
306
307 pillar_roots:
308   base:
309     - ${P_DIR}
310 EOFSM
311 fi
312
313 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
314
315 # Get the formula and dependencies
316 cd ${F_DIR} || exit 1
317 echo "Cloning formulas"
318 rm -rf ${F_DIR}/* || exit 1
319 git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
320 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" -b "${DOCKER_TAG}" )
321
322 echo "...locale"
323 git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
324 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" -b "${LOCALE_TAG}" )
325
326 echo "...nginx"
327 git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
328 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" -b "${NGINX_TAG}" )
329
330 echo "...postgres"
331 git clone --quiet https://github.com/saltstack-formulas/postgres-formula.git ${F_DIR}/postgres
332 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" -b "${POSTGRES_TAG}" )
333
334 echo "...letsencrypt"
335 git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
336 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" -b "${LETSENCRYPT_TAG}" )
337
338 echo "...arvados"
339 git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
340
341 # If we want to try a specific branch of the formula
342 if [ "x${BRANCH}" != "x" ]; then
343   ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
344 elif [ "x${ARVADOS_TAG}" != "x" ]; then
345 ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
346 fi
347
348 if [ "x${VAGRANT}" = "xyes" ]; then
349   EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
350   SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
351   SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
352 else
353   EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
354   SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
355   SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
356 fi
357
358 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
359
360 echo "Writing pillars and states"
361
362 # Replace variables (cluster,  domain, etc) in the pillars, states and tests
363 # to ease deployment for newcomers
364 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
365   echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
366   exit 1
367 fi
368 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
369   sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
370        s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
371        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
372        s#__CLUSTER__#${CLUSTER}#g;
373        s#__DOMAIN__#${DOMAIN}#g;
374        s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
375        s#__IP_INT__#${IP_INT}#g;
376        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
377        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
378        s#__INITIAL_USER__#${INITIAL_USER}#g;
379        s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
380        s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
381        s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
382        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
383        s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
384        s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
385        s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
386        s#__RELEASE__#${RELEASE}#g;
387        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
388        s#__VERSION__#${VERSION}#g;
389        s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
390        s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
391        s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
392        s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
393        s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
394        s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
395        s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
396        s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
397        s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
398        s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
399        s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
400        s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
401        s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
402        s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
403        s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
404        s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
405        s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
406   "${f}" > "${P_DIR}"/$(basename "${f}")
407 done
408
409 if [ "x${TEST}" = "xyes" ] && [ ! -d "${SOURCE_TESTS_DIR}" ]; then
410   echo "You requested to run tests, but ${SOURCE_TESTS_DIR} does not exist or is not a directory. Exiting."
411   exit 1
412 fi
413 mkdir -p ${T_DIR}
414 # Replace cluster and domain name in the test files
415 for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
416   sed "s#__CLUSTER__#${CLUSTER}#g;
417        s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
418        s#__DOMAIN__#${DOMAIN}#g;
419        s#__IP_INT__#${IP_INT}#g;
420        s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
421        s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
422        s#__INITIAL_USER__#${INITIAL_USER}#g;
423        s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
424        s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g" \
425   "${f}" > ${T_DIR}/$(basename "${f}")
426 done
427 chmod 755 ${T_DIR}/run-test.sh
428
429 # Replace helper state files that differ from the formula's examples
430 if [ -d "${SOURCE_STATES_DIR}" ]; then
431   mkdir -p "${F_DIR}"/extra/extra
432
433   for f in $(ls "${SOURCE_STATES_DIR}"/*); do
434     sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
435          s#__CLUSTER__#${CLUSTER}#g;
436          s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
437          s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
438          s#__DOMAIN__#${DOMAIN}#g;
439          s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
440          s#__IP_INT__#${IP_INT}#g;
441          s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
442          s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
443          s#__INITIAL_USER__#${INITIAL_USER}#g;
444          s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
445          s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
446          s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
447          s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
448          s#__RELEASE__#${RELEASE}#g;
449          s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
450          s#__VERSION__#${VERSION}#g;
451          s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
452          s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
453          s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
454          s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
455          s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
456          s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
457          s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
458          s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
459          s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
460          s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
461          s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
462          s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
463          s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
464          s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
465          s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
466          s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
467     "${f}" > "${F_DIR}/extra/extra"/$(basename "${f}")
468   done
469 fi
470
471 # Now, we build the SALT states/pillars trees
472 # As we need to separate both states and pillars in case we want specific
473 # roles, we iterate on both at the same time
474
475 # States
476 cat > ${S_DIR}/top.sls << EOFTSLS
477 base:
478   '*':
479     - locale
480 EOFTSLS
481
482 # Pillars
483 cat > ${P_DIR}/top.sls << EOFPSLS
484 base:
485   '*':
486     - locale
487     - arvados
488 EOFPSLS
489
490 # States, extra states
491 if [ -d "${F_DIR}"/extra/extra ]; then
492   SKIP_SNAKE_OIL="snakeoil_certs"
493
494   if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
495     # In dev mode, we create some snake oil certs that we'll
496     # use as CUSTOM_CERTS, so we don't skip the states file.
497     # Same when using self-signed certificates.
498     SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
499   fi
500   for f in $(ls "${F_DIR}"/extra/extra/*.sls | grep -v ${SKIP_SNAKE_OIL}); do
501   echo "    - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${S_DIR}/top.sls
502   done
503   # Use byo or self-signed certificates
504   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
505     mkdir -p "${F_DIR}"/extra/extra/files
506   fi
507 fi
508
509 # If we want specific roles for a node, just add the desired states
510 # and its dependencies
511 if [ -z "${ROLES}" ]; then
512   # States
513   echo "    - nginx.passenger" >> ${S_DIR}/top.sls
514   # Currently, only available on config_examples/multi_host/aws
515   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
516     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
517       grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - extra.aws_credentials" >> ${S_DIR}/top.sls
518     fi
519     grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
520   else
521     # Use custom certs
522     # Copy certs to formula extra/files
523     # In dev mode, the files will be created and put in the destination directory by the
524     # snakeoil_certs.sls state file
525     mkdir -p /srv/salt/certs
526     cp -rv ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
527     # We add the custom_certs state
528     grep -q "custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
529   fi
530
531   echo "    - postgres" >> ${S_DIR}/top.sls
532   echo "    - docker.software" >> ${S_DIR}/top.sls
533   echo "    - arvados" >> ${S_DIR}/top.sls
534
535   # Pillars
536   echo "    - docker" >> ${P_DIR}/top.sls
537   echo "    - nginx_api_configuration" >> ${P_DIR}/top.sls
538   echo "    - nginx_controller_configuration" >> ${P_DIR}/top.sls
539   echo "    - nginx_keepproxy_configuration" >> ${P_DIR}/top.sls
540   echo "    - nginx_keepweb_configuration" >> ${P_DIR}/top.sls
541   echo "    - nginx_passenger" >> ${P_DIR}/top.sls
542   echo "    - nginx_websocket_configuration" >> ${P_DIR}/top.sls
543   echo "    - nginx_webshell_configuration" >> ${P_DIR}/top.sls
544   echo "    - nginx_workbench2_configuration" >> ${P_DIR}/top.sls
545   echo "    - nginx_workbench_configuration" >> ${P_DIR}/top.sls
546   echo "    - postgresql" >> ${P_DIR}/top.sls
547
548   if [ "${SSL_MODE}" = "lets-encrypt" ]; then
549     if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
550       grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
551     fi
552     grep -q "letsencrypt" ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
553
554     # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
555     for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
556       if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
557         # Are we in a single-host-single-hostname env?
558         CERT_NAME=${HOSTNAME_EXT}
559       else
560         # We are in a single-host-multiple-hostnames env
561         CERT_NAME=${c}.${CLUSTER}.${DOMAIN}
562       fi
563
564       sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${CERT_NAME}*/g;
565               s#__CERT_PEM__#/etc/letsencrypt/live/${CERT_NAME}/fullchain.pem#g;
566               s#__CERT_KEY__#/etc/letsencrypt/live/${CERT_NAME}/privkey.pem#g" \
567       ${P_DIR}/nginx_${c}_configuration.sls
568     done
569   else
570     # Use custom certs (either dev mode or prod)
571     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
572     # And add the certs in the custom_certs pillar
573     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
574     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
575
576     # Are we in a single-host-single-hostname env?
577     if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
578       # Are we in a single-host-single-hostname env?
579       CERT_NAME=${HOSTNAME_EXT}
580     else
581       # We are in a multiple-hostnames env
582       CERT_NAME=${c}
583     fi
584     for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
585       if [ "${SSL_MODE}" = "bring-your-own" ]; then
586         copy_custom_cert ${CUSTOM_CERTS_DIR} $c
587       fi
588       grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo "  - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
589
590       # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
591       sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${CERT_NAME}.pem/g;
592               s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
593               s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
594       ${P_DIR}/nginx_${c}_configuration.sls
595     done
596   fi
597 else
598   # If we add individual roles, make sure we add the repo first
599   echo "    - arvados.repo" >> ${S_DIR}/top.sls
600   # We add the extra_custom_certs state
601   grep -q "extra.custom_certs"    ${S_DIR}/top.sls || echo "    - extra.custom_certs" >> ${S_DIR}/top.sls
602
603   # And we add the basic part for the certs pillar
604   if [ "${SSL_MODE}" != "lets-encrypt" ]; then
605     # And add the certs in the custom_certs pillar
606     echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
607     echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
608     grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo "    - extra_custom_certs" >> ${P_DIR}/top.sls
609   fi
610
611   for R in ${ROLES}; do
612     case "${R}" in
613       "database")
614         # States
615         echo "    - postgres" >> ${S_DIR}/top.sls
616         # Pillars
617         echo '    - postgresql' >> ${P_DIR}/top.sls
618       ;;
619       "api")
620         # States
621         # FIXME: https://dev.arvados.org/issues/17352
622         grep -q "postgres.client" ${S_DIR}/top.sls || echo "    - postgres.client" >> ${S_DIR}/top.sls
623         grep -q "nginx.passenger" ${S_DIR}/top.sls || echo "    - nginx.passenger" >> ${S_DIR}/top.sls
624         ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
625         ### after it. So we add this here as we are, after all, sharing the host for api and controller
626         # Currently, only available on config_examples/multi_host/aws
627         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
628           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
629             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
630           fi
631           grep -q "letsencrypt" ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
632         else
633           # Use custom certs
634           if [ "${SSL_MODE}" = "bring-your-own" ]; then
635             copy_custom_cert ${CUSTOM_CERTS_DIR} controller
636           fi
637           grep -q controller ${P_DIR}/extra_custom_certs.sls || echo "  - controller" >> ${P_DIR}/extra_custom_certs.sls
638         fi
639         grep -q "arvados.${R}" ${S_DIR}/top.sls    || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
640         # Pillars
641         grep -q "aws_credentials" ${P_DIR}/top.sls          || echo "    - aws_credentials" >> ${P_DIR}/top.sls
642         grep -q "postgresql" ${P_DIR}/top.sls               || echo "    - postgresql" >> ${P_DIR}/top.sls
643         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
644         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
645       ;;
646       "controller" | "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
647         # States
648         grep -q "nginx.passenger" ${S_DIR}/top.sls || echo "    - nginx.passenger" >> ${S_DIR}/top.sls
649         # Currently, only available on config_examples/multi_host/aws
650         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
651           if [ "x${USE_LETSENCRYPT_ROUTE53}" = "xyes" ]; then
652             grep -q "aws_credentials" ${S_DIR}/top.sls || echo "    - aws_credentials" >> ${S_DIR}/top.sls
653           fi
654           grep -q "letsencrypt"     ${S_DIR}/top.sls || echo "    - letsencrypt" >> ${S_DIR}/top.sls
655         else
656           # Use custom certs, special case for keepweb
657           if [ ${R} = "keepweb" ]; then
658             if [ "${SSL_MODE}" = "bring-your-own" ]; then
659               copy_custom_cert ${CUSTOM_CERTS_DIR} download
660               copy_custom_cert ${CUSTOM_CERTS_DIR} collections
661             fi
662           else
663             if [ "${SSL_MODE}" = "bring-your-own" ]; then
664               copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
665             fi
666           fi
667         fi
668         # webshell role is just a nginx vhost, so it has no state
669         if [ "${R}" != "webshell" ]; then
670           grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
671         fi
672         # Pillars
673         grep -q "nginx_passenger" ${P_DIR}/top.sls          || echo "    - nginx_passenger" >> ${P_DIR}/top.sls
674         grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo "    - nginx_${R}_configuration" >> ${P_DIR}/top.sls
675         # Special case for keepweb
676         if [ ${R} = "keepweb" ]; then
677           grep -q "nginx_download_configuration" ${P_DIR}/top.sls || echo "    - nginx_download_configuration" >> ${P_DIR}/top.sls
678           grep -q "nginx_collections_configuration" ${P_DIR}/top.sls || echo "    - nginx_collections_configuration" >> ${P_DIR}/top.sls
679         fi
680
681         # Currently, only available on config_examples/multi_host/aws
682         if [ "${SSL_MODE}" = "lets-encrypt" ]; then
683           if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
684             grep -q "aws_credentials" ${P_DIR}/top.sls || echo "    - aws_credentials" >> ${P_DIR}/top.sls
685           fi
686           grep -q "letsencrypt"     ${P_DIR}/top.sls || echo "    - letsencrypt" >> ${P_DIR}/top.sls
687           grep -q "letsencrypt_${R}_configuration" ${P_DIR}/top.sls || echo "    - letsencrypt_${R}_configuration" >> ${P_DIR}/top.sls
688
689           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
690           # Special case for keepweb
691           if [ ${R} = "keepweb" ]; then
692             for kwsub in download collections; do
693               sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${CLUSTER}.${DOMAIN}*/g;
694                       s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
695                       s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
696               ${P_DIR}/nginx_${kwsub}_configuration.sls
697             done
698           else
699             sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${CLUSTER}.${DOMAIN}*/g;
700                     s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
701                     s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
702             ${P_DIR}/nginx_${R}_configuration.sls
703           fi
704         else
705           # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
706           # Special case for keepweb
707           if [ ${R} = "keepweb" ]; then
708             for kwsub in download collections; do
709               sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
710                       s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
711                       s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
712               ${P_DIR}/nginx_${kwsub}_configuration.sls
713               grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo "  - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
714             done
715           else
716             sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
717                     s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
718                     s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
719             ${P_DIR}/nginx_${R}_configuration.sls
720             grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo "  - ${R}" >> ${P_DIR}/extra_custom_certs.sls
721           fi
722         fi
723       ;;
724       "shell")
725         # States
726         grep -q "docker" ${S_DIR}/top.sls       || echo "    - docker.software" >> ${S_DIR}/top.sls
727         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
728         # Pillars
729         grep -q "docker" ${P_DIR}/top.sls       || echo "    - docker" >> ${P_DIR}/top.sls
730       ;;
731       "dispatcher")
732         # States
733         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
734         # Pillars
735         # ATM, no specific pillar needed
736       ;;
737       "keepstore")
738         # States
739         grep -q "arvados.${R}" ${S_DIR}/top.sls || echo "    - arvados.${R}" >> ${S_DIR}/top.sls
740         # Pillars
741         # ATM, no specific pillar needed
742       ;;
743       *)
744         echo "Unknown role ${R}"
745         exit 1
746       ;;
747     esac
748   done
749 fi
750
751 if [ "${DUMP_CONFIG}" = "yes" ]; then
752   # We won't run the rest of the script because we're just dumping the config
753   exit 0
754 fi
755
756 # FIXME! #16992 Temporary fix for psql call in arvados-api-server
757 if [ -e /root/.psqlrc ]; then
758   if ! ( grep 'pset pager off' /root/.psqlrc ); then
759     RESTORE_PSQL="yes"
760     cp /root/.psqlrc /root/.psqlrc.provision.backup
761   fi
762 else
763   DELETE_PSQL="yes"
764 fi
765
766 echo '\pset pager off' >> /root/.psqlrc
767 # END FIXME! #16992 Temporary fix for psql call in arvados-api-server
768
769 # Now run the install
770 salt-call --local state.apply -l ${LOG_LEVEL}
771
772 # FIXME! #16992 Temporary fix for psql call in arvados-api-server
773 if [ "x${DELETE_PSQL}" = "xyes" ]; then
774   echo "Removing .psql file"
775   rm /root/.psqlrc
776 fi
777
778 if [ "x${RESTORE_PSQL}" = "xyes" ]; then
779   echo "Restoring .psql file"
780   mv -v /root/.psqlrc.provision.backup /root/.psqlrc
781 fi
782 # END FIXME! #16992 Temporary fix for psql call in arvados-api-server
783
784 # Leave a copy of the Arvados CA so the user can copy it where it's required
785 if [ "$DEV_MODE" = "yes" ]; then
786   echo "Copying the Arvados CA certificate to the installer dir, so you can import it"
787   # If running in a vagrant VM, also add default user to docker group
788   if [ "x${VAGRANT}" = "xyes" ]; then
789     cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
790
791     echo "Adding the vagrant user to the docker group"
792     usermod -a -G docker vagrant
793   else
794     cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
795   fi
796 fi
797
798 # Test that the installation finished correctly
799 if [ "x${TEST}" = "xyes" ]; then
800   cd ${T_DIR}
801   # If we use RVM, we need to run this with it, or most ruby commands will fail
802   RVM_EXEC=""
803   if [ -x /usr/local/rvm/bin/rvm-exec ]; then
804     RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
805   fi
806   ${RVM_EXEC} ./run-test.sh
807 fi